---
title: XRReferenceSpaceType
slug: Web/API/XRReferenceSpaceType
tags:
  - API
  - AR
  - Enumerated
  - Enumerated Type
  - Reality
  - Reference
  - Type
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRReferenceSpace
  - XRReferenceSpaceType
  - augmented
  - space
  - tracking
---
<p>{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The <code><strong>XRReferenceSpaceType</strong></code> enumerated type defines the strings which identify the types of reference spaces supported by WebXR.</span> This type is used when calling the {{domxref("XRSession.requestReferenceSpace", "requestReferenceSpace()")}} method to obtain a reference space for an {{domxref("XRSession")}}.</p>

<h2 id="Values">Values</h2>

<p>The reference space returned by {{domxref("XRSession.requestReferenceSpace()")}} is either {{domxref("XRReferenceSpace")}} or {{domxref("XRBoundedReferenceSpace")}}. The "Interface" column in the table below indicates which of the two types is returned for each reference space type constant..</p>

<h3 id="Reference_space_descriptors">Reference space descriptors</h3>

<p>The types of reference space are listed in the table below, with brief information about their use cases and which interface is used to implement them.</p>

<div id="foo">
<table class="standard-table" id="value-list">
 <thead>
  <tr>
   <th scope="col">XRReferenceSpaceType</th>
   <th scope="col">Description</th>
   <th scope="col">Interface</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a id="bounded-floor"><code>bounded-floor</code></a></td>
   <td>Similar to the <code>local</code> type, except the user is not expected to move outside a predetermined boundary, given by the {{domxref("XRBoundedReferenceSpace.boundsGeometry", "boundsGeometry")}} in the returned object.</td>
   <td>{{domxref("XRBoundedReferenceSpace")}}</td>
  </tr>
  <tr>
   <td><a id="local"><code>local</code></a></td>
   <td>
    <p>A tracking space whose native origin is located near the viewer's position at the time the session was created. The exact position depends on the underlying platform and implementation. The user isn't expected to move much if at all beyond their starting position, and tracking is optimized for this use case.</p>

    <p>For devices with six degrees of freedom (6DoF) tracking, the <code>local</code> reference space tries to keep the origin stable relative to the environment.</p>
   </td>
   <td>{{domxref("XRReferenceSpace")}}</td>
  </tr>
  <tr>
   <td><a id="local-floor"><code>local-floor</code></a></td>
   <td>Similar to the <code>local</code> type, except the starting position is placed in a safe location for the viewer to stand, where the value of the y axis is 0 at floor level. If that floor level isn't known, the {{Glossary("user agent")}} will estimate the floor level. If the estimated floor level is non-zero, the browser is expected to round it such a way as to avoid fingerprinting (likely to the nearest centimeter).</td>
   <td>{{domxref("XRReferenceSpace")}}</td>
  </tr>
  <tr>
   <td><a id="unbounded"><code>unbounded</code></a></td>
   <td>A tracking space which allows the user total freedom of movement, possibly over extremely long distances from their origin point. The viewer isn't tracked at all; tracking is optimized for stability around the user's current position, so the native origin may drift as needed to accommodate that need.</td>
   <td>{{domxref("XRReferenceSpace")}}</td>
  </tr>
  <tr>
   <td><a id="viewer"><code>viewer</code></a></td>
   <td>A tracking space whose native origin tracks the viewer's position and orientation. This is used for environments in which the user can physically move around, and is supported by all instances of {{domxref("XRSession")}}, both immersive and inline, though it's most useful for inline sessions. It's particularly useful when determining the distance between the viewer and an input, or when working with offset spaces. Otherwise, typically, one of the other reference space types will be used more often.</td>
   <td>{{domxref("XRReferenceSpace")}}</td>
  </tr>
 </tbody>
</table>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#enumdef-xrreferencespacetype','XRReferenceSpaceType')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRReferenceSpaceType")}}</p>
